diff -u gnome-core-1.4.0.1-colin/applets/tasklist/tasklist_menu.c gnome-core-1.4.0.1/applets/tasklist/tasklist_menu.c
--- gnome-core-1.4.0.1-colin/applets/tasklist/tasklist_menu.c	Mon Feb 26 14:50:22 2001
+++ gnome-core-1.4.0.1/applets/tasklist/tasklist_menu.c	Mon Jul 22 14:54:58 2002
@@ -8,6 +8,7 @@
 #define d(x)
 
 /* Callback for menu positioning */
+
 static void
 cb_menu_position (GtkMenu *menu, gint *x, gint *y, gpointer user_data)
 {
@@ -24,7 +25,6 @@
 
 	gtk_widget_get_child_requisition (GTK_WIDGET (menu), &mreq);
 	gdk_window_get_origin (task->tasklist->area->window, &wx, &wy);
-
 	switch (applet_widget_get_panel_orient (APPLET_WIDGET (task->tasklist->applet))) {
 	case ORIENT_UP:
 		*x = wx + task->x;
@@ -573,9 +573,13 @@
 	GdkPixmap *pix;
 	GdkBitmap *bit;
 	gchar *s;
-
+	int width = 0, gx, gy;
 	static GwmhDesk *desk = NULL;
-
+	
+	gdk_window_get_origin (task->tasklist->area->window, &gx, &gy);
+	
+	width = gdk_screen_width() - group->x - gx - 30;
+	
 	gdk_pixbuf_render_pixmap_and_mask (
 		task->gwmh_task->iconified
 		? task->icon->minimized
@@ -591,7 +595,7 @@
 	task->menuitem = gtk_pixmap_menu_item_new ();
 	gtk_pixmap_menu_item_set_pixmap (GTK_PIXMAP_MENU_ITEM (task->menuitem), pixmap);
 
-	s = tasklist_task_get_label (task, group->width, FALSE);
+	s = tasklist_task_get_label (task, width, FALSE);
 	label = gtk_label_new (s);
 	g_free (s);
 	gtk_container_add (GTK_CONTAINER (task->menuitem), label);
